package com.mortals.xhx.module.care.web;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.care.model.CareConfigQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.care.model.CareConfigEntity;
import com.mortals.xhx.module.care.service.CareConfigService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import java.util.Arrays;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 主动关怀配置
*
* @author zxfei
* @date 2023-04-09
*/
@RestController
@RequestMapping("care/config")
public class CareConfigController extends BaseCRUDJsonBodyMappingController<CareConfigService,CareConfigEntity,Long> {

    @Autowired
    private ParamService paramService;

    public CareConfigController(){
        super.setModuleDesc( "主动关怀配置");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "used", paramService.getParamBySecondOrganize("CareConfig","used"));
        this.addDict(model, "monday", paramService.getParamBySecondOrganize("CareConfig","monday"));
        this.addDict(model, "tuesday", paramService.getParamBySecondOrganize("CareConfig","tuesday"));
        this.addDict(model, "wednesday", paramService.getParamBySecondOrganize("CareConfig","wednesday"));
        this.addDict(model, "thursday", paramService.getParamBySecondOrganize("CareConfig","thursday"));
        this.addDict(model, "friday", paramService.getParamBySecondOrganize("CareConfig","friday"));
        this.addDict(model, "saturday", paramService.getParamBySecondOrganize("CareConfig","saturday"));
        this.addDict(model, "sunday", paramService.getParamBySecondOrganize("CareConfig","sunday"));
        this.addDict(model, "msgRecipients", paramService.getParamBySecondOrganize("CareConfig","msgRecipients"));
        super.init(model, context);
    }

    @Override
    protected void saveBefore(CareConfigEntity entity, Map<String, Object> model, Context context) throws AppException {
        CareConfigEntity careConfigEntity = this.service.selectOne(new CareConfigQuery(), context);
        if(!ObjectUtils.isEmpty(careConfigEntity)){
           entity.setId(careConfigEntity.getId());
        }
        super.saveBefore(entity, model, context);
    }
}